(* 
    File:	 /home/piero/PPorts.thy
    Theory Name: PPorts
    Logic Image: tilco

Teoria delle porte di comunicazione primitive tipizzate.
*)

PPorts  =  tilcoExt +

classes
  Port    < term
  inPort  < Port
  outPort < Port
types
  (* porte primitive tipizzate*)
  'a p_inPort
  'a p_outPort
arities
  p_inPort  :: (term) inPort
  p_outPort :: (term) outPort
    
consts
(* primitive di trasmissione, ricezione e di collegamento *)
  p_send       :: ['a p_outPort, 'a] => tbool ("_.psend _" [50,50] 50)
  p_receiveAck ::  'a p_outPort => tbool      ("_.preceiveAck" [50] 50)
  p_receiveReq ::  'a p_outPort => tbool      ("_.preceiveReq" [50] 50)
  
  p_receive :: ['a p_inPort,'a] => tbool ("_.preceive _" [50,50] 50)
  p_sendAck ::  'a p_inPort => tbool     ("_.psendAck" [50] 50)
  p_sendReq ::  'a p_inPort => tbool     ("_.psendReq" [50] 50)
  
  connectd  :: ['a p_outPort,nat,'a p_inPort] => bool
    ("_ ->_>- _" [50,50,50] 50)

syntax
  connect0  :: ['a p_outPort,'a p_inPort] => bool ("_ ->- _"  [50,50] 50)
  connect1  :: ['a p_outPort,'a p_inPort] => bool ("_ ->>- _" [50,50] 50)  
translations
  "outP ->- inP"  == "outP ->0>- inP"
  "outP ->>- inP" == "outP ->1>- inP"
rules
  (* regola per la trasmissione/ricezione dei valori, degli Ack e dei Req*)
  p_tr_msg_rule " (outP ->d>- inP) -->   \
\                 rule((outP.psend k) #= (inP.preceive k)@single($#d))"
  p_tr_ack_rule " (outP ->d>- inP) -->   \
\                 rule((inP.psendAck) #= (outP.preceiveAck)@single($#d))"
  p_tr_req_rule " (outP ->d>- inP) -->   \
\                 rule((inP.psendReq) #= (outP.preceiveReq)@single($#d))"
  
  (* in ogni istante si puo' inviare e ricevere un solo valore *)
  p_uni_send_rule " rule( ((outP.psend k) #& (outP.psend v)) #-->   \
\                         ((const v)#=(const k)))"
  p_uni_rec_rule  " rule( ((inP.preceive k) #& (inP.preceive v)) #-->   \
\                         ((const v)#=(const k)))"
  
end
